-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Discrete Axis Zooming and Panning
Discrete data support is one of many strengths of the Chart component. In this example, you can zoom data in the Chart using another DevExtreme JavaScript UI component, the RangeSelector.
Was this demo helpful?
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const chart = $('#zoomedChart').dxChart({
palette: 'soft',
title: 'The Chemical Composition of the Earth Layers',
valueAxis: {
label: {
customizeText() {
return `${this.valueText}%`;
},
},
},
dataSource,
series,
commonSeriesSettings: {
type: 'bar',
ignoreEmptyPoints: true,
},
legend: {
border: {
visible: true,
},
visible: true,
verticalAlignment: 'top',
horizontalAlignment: 'right',
orientation: 'horizontal',
},
}).dxChart('instance');
$('#range-selector').dxRangeSelector({
size: {
height: 120,
},
margin: {
left: 10,
},
scale: {
minorTickCount: 1,
},
dataSource,
chart: {
palette: 'soft',
commonSeriesSettings: {
type: 'bar',
ignoreEmptyPoints: true,
},
series,
},
behavior: {
valueChangeMode: 'onHandleMove',
},
onValueChanged(e) {
chart.getArgumentAxis().visualRange(e.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart-demo">
<div id="zoomedChart"></div>
<div id="range-selector"></div>
</div>
</div>
</body>
</html>
#zoomedChart {
margin-bottom: 20px;
}
const series = [{
name: 'Si',
valueField: 'Si',
}, {
name: 'Fe',
valueField: 'Fe',
}, {
name: 'Ni',
valueField: 'Ni',
}, {
name: 'S',
valueField: 'S',
}, {
name: 'O',
valueField: 'O',
}, {
name: 'Mg',
valueField: 'Mg',
}, {
name: 'Al',
valueField: 'Al',
}, {
name: 'K',
valueField: 'K',
}, {
name: 'Na',
valueField: 'Na',
}];
const dataSource = [{
arg: 'Inner Core',
Si: 7.35,
Fe: 79.39,
Ni: 5.2,
S: 2.3,
O: 4.1,
}, {
arg: 'Outer Core',
Si: 7.33,
Fe: 78.56,
Ni: 5.2,
S: 2.7,
O: 4.2,
}, {
arg: 'Lower Mantle',
Si: 21.5,
Fe: 5.8,
O: 44.8,
Mg: 22.8,
Al: 2.2,
Ca: 2.3,
Na: 0.3,
K: 0.03,
}, {
arg: 'Upper Mantle',
Si: 28.1,
Mg: 23.2,
Fe: 4.3,
Al: 1.2,
Ca: 2.2,
O: 40.3,
Na: 0.2,
}, {
arg: 'Lower Crust',
O: 46.6,
Si: 27.7,
Al: 8.1,
Fe: 5,
Ca: 3.6,
Na: 2.8,
K: 2.6,
Mg: 1.5,
}, {
arg: 'Upper Crust',
O: 47,
Si: 29.5,
Al: 8.05,
Fe: 4.66,
Ca: 2.96,
Na: 2.5,
K: 2.5,
Mg: 1.87,
}];

-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Charts - Discrete Axis Zooming and Panning
Discrete data support is one of many strengths of the Chart component. In this example, you can zoom data in the Chart using another DevExtreme JavaScript UI component, the RangeSelector.
Backend API
<template>
<div>
<div id="chart-demo">
<DxChart
id="zoomedChart"
:data-source="dataSource"
palette="Soft"
title="The Chemical Composition of the Earth Layers"
>
<DxSeries
v-for="item in series"
:value-field="item.valueField"
:name="item.name"
:key="item.name"
/>
<DxCommonSeriesSettings
:ignore-empty-points="true"
type="bar"
/>
<DxValueAxis>
<DxLabel :customize-text="customizeText"/>
</DxValueAxis>
<DxArgumentAxis :visual-range="range"/>
<DxLegend
:visible="true"
vertical-alignment="top"
horizontal-alignment="right"
orientation="horizontal"
>
<DxBorder :visible="true"/>
</DxLegend>
</DxChart>
<DxRangeSelector
:data-source="dataSource"
v-model:value="range"
>
<DxSize :height="120"/>
<DxMargin :left="10"/>
<DxScale :minor-tick-count="1"/>
<DxRsChart
palette="Soft"
>
<DxRsChartSeries
v-for="item in series"
:value-field="item.valueField"
:name="item.name"
:key="item.name"
/>
<DxCommonSeriesSettingsOptions
:ignore-empty-points="true"
type="bar"
/>
</DxRsChart>
<DxBehavior value-change-mode="onHandleMove"/>
</DxRangeSelector>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxChart,
DxValueAxis,
DxArgumentAxis,
DxLabel,
DxLegend,
DxBorder,
DxCommonSeriesSettings,
DxSeries,
} from 'devextreme-vue/chart';
import {
DxRangeSelector,
DxSize,
DxMargin,
DxScale,
DxChart as DxRsChart,
DxBehavior,
DxCommonSeriesSettings as DxCommonSeriesSettingsOptions,
DxSeries as DxRsChartSeries,
} from 'devextreme-vue/range-selector';
import { dataSource } from './data.ts';
const range = ref([]);
const series = [{
name: 'Si',
valueField: 'Si',
}, {
name: 'Fe',
valueField: 'Fe',
}, {
name: 'Ni',
valueField: 'Ni',
}, {
name: 'S',
valueField: 'S',
}, {
name: 'O',
valueField: 'O',
}, {
name: 'Mg',
valueField: 'Mg',
}, {
name: 'Al',
valueField: 'Al',
}, {
name: 'K',
valueField: 'K',
}, {
name: 'Na',
valueField: 'Na',
}];
const customizeText = ({ valueText }: { valueText: string }) => `${valueText}%`;
</script>
<style scoped>
#zoomedChart {
margin-bottom: 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const dataSource = [{
arg: 'Inner Core',
Si: 7.35,
Fe: 79.39,
Ni: 5.2,
S: 2.3,
O: 4.1,
}, {
arg: 'Outer Core',
Si: 7.33,
Fe: 78.56,
Ni: 5.2,
S: 2.7,
O: 4.2,
}, {
arg: 'Lower Mantle',
Si: 21.5,
Fe: 5.8,
O: 44.8,
Mg: 22.8,
Al: 2.2,
Ca: 2.3,
Na: 0.3,
K: 0.03,
}, {
arg: 'Upper Mantle',
Si: 28.1,
Mg: 23.2,
Fe: 4.3,
Al: 1.2,
Ca: 2.2,
O: 40.3,
Na: 0.2,
}, {
arg: 'Lower Crust',
O: 46.6,
Si: 27.7,
Al: 8.1,
Fe: 5,
Ca: 3.6,
Na: 2.8,
K: 2.6,
Mg: 1.5,
}, {
arg: 'Upper Crust',
O: 47,
Si: 29.5,
Al: 8.05,
Fe: 4.66,
Ca: 2.96,
Na: 2.5,
K: 2.5,
Mg: 1.87,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<div id="chart-demo">
<dx-chart
id="zoomedChart"
palette="soft"
[dataSource]="chemicalComposition"
title="The Chemical Composition of the Earth Layers"
>
@for(item of seriesSource; track item.name) {
<dxi-chart-series [valueField]="item.valueField" [name]="item.name">
</dxi-chart-series>
}
<dxo-chart-common-series-settings type="bar" [ignoreEmptyPoints]="true">
</dxo-chart-common-series-settings>
<dxi-chart-value-axis>
<dxo-chart-label [customizeText]="customizeText"></dxo-chart-label>
</dxi-chart-value-axis>
<dxo-chart-argument-axis #argumentAxis> </dxo-chart-argument-axis>
<dxo-chart-legend
[visible]="true"
verticalAlignment="top"
horizontalAlignment="right"
orientation="horizontal"
>
<dxo-chart-border [visible]="true"></dxo-chart-border>
</dxo-chart-legend>
</dx-chart>
<dx-range-selector
[dataSource]="chemicalComposition"
[(value)]="argumentAxis.visualRange"
>
<dxo-range-selector-size [height]="120"></dxo-range-selector-size>
<dxo-range-selector-margin [left]="10"></dxo-range-selector-margin>
<dxo-range-selector-scale [minorTickCount]="1"></dxo-range-selector-scale>
<dxo-range-selector-behavior
valueChangeMode="onHandleMove"
></dxo-range-selector-behavior>
<dxo-range-selector-chart palette="soft">
<dxo-range-selector-common-series-settings
type="bar"
[ignoreEmptyPoints]="true"
>
</dxo-range-selector-common-series-settings>
@for(item of seriesSource; track item.name) {
<dxi-range-selector-series
[valueField]="item.valueField"
[name]="item.name"
>
</dxi-range-selector-series>
}
</dxo-range-selector-chart>
</dx-range-selector>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxRangeSelectorModule } from 'devextreme-angular';
import { DxChartModule, DxChartTypes } from 'devextreme-angular/ui/chart';
import { Service, ChemicalComposition, SeriesDescription } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
DxRangeSelectorModule,
],
})
export class AppComponent {
chemicalComposition: ChemicalComposition[];
seriesSource: SeriesDescription[];
constructor(service: Service) {
this.chemicalComposition = service.getChemicalComposition();
this.seriesSource = service.getSeries();
}
customizeText: DxChartTypes.ValueAxisLabel['customizeText'] = ({ valueText }) => `${valueText}%`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #zoomedChart {
margin-bottom: 20px;
}
import { Injectable } from '@angular/core';
export class ChemicalComposition {
arg: string;
Si?: number;
Fe?: number;
Ni?: number;
S?: number;
O?: number;
Mg?: number;
Al?: number;
Ca?: number;
Na?: number;
K?: number;
}
export class SeriesDescription {
name: string;
valueField: string;
}
const chemicalComposition: ChemicalComposition[] = [{
arg: 'Inner Core',
Si: 7.35,
Fe: 79.39,
Ni: 5.2,
S: 2.3,
O: 4.1,
}, {
arg: 'Outer Core',
Si: 7.33,
Fe: 78.56,
Ni: 5.2,
S: 2.7,
O: 4.2,
}, {
arg: 'Lower Mantle',
Si: 21.5,
Fe: 5.8,
O: 44.8,
Mg: 22.8,
Al: 2.2,
Ca: 2.3,
Na: 0.3,
K: 0.03,
}, {
arg: 'Upper Mantle',
Si: 28.1,
Mg: 23.2,
Fe: 4.3,
Al: 1.2,
Ca: 2.2,
O: 40.3,
Na: 0.2,
}, {
arg: 'Lower Crust',
O: 46.6,
Si: 27.7,
Al: 8.1,
Fe: 5,
Ca: 3.6,
Na: 2.8,
K: 2.6,
Mg: 1.5,
}, {
arg: 'Upper Crust',
O: 47,
Si: 29.5,
Al: 8.05,
Fe: 4.66,
Ca: 2.96,
Na: 2.5,
K: 2.5,
Mg: 1.87,
}];
const seriesSource: SeriesDescription[] = [{
name: 'Si',
valueField: 'Si',
}, {
name: 'Fe',
valueField: 'Fe',
}, {
name: 'Ni',
valueField: 'Ni',
}, {
name: 'S',
valueField: 'S',
}, {
name: 'O',
valueField: 'O',
}, {
name: 'Mg',
valueField: 'Mg',
}, {
name: 'Al',
valueField: 'Al',
}, {
name: 'K',
valueField: 'K',
}, {
name: 'Na',
valueField: 'Na',
}];
@Injectable()
export class Service {
getChemicalComposition(): ChemicalComposition[] {
return chemicalComposition;
}
getSeries(): SeriesDescription[] {
return seriesSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React, { useCallback, useState } from 'react';
import Chart, {
ValueAxis,
Label,
Legend,
ArgumentAxis,
CommonSeriesSettings,
Border,
Series,
} from 'devextreme-react/chart';
import RangeSelector, {
Size,
Chart as ChartOptions,
Margin,
Scale,
Behavior,
CommonSeriesSettings as CommonSeriesSettingsOptions,
Series as RsChartSeries,
type RangeSelectorTypes,
} from 'devextreme-react/range-selector';
import type { VisualRange } from 'devextreme-react/common/charts';
import { series, dataSource } from './data.ts';
const seriesList = series.map((item) => <Series
valueField={item.valueField}
name={item.name}
key={item.name} />);
const rsChartSeriesList = series.map((item) => <RsChartSeries
valueField={item.valueField}
name={item.name}
key={item.name} />);
function formatValueAxisLabel(e: { valueText: string; }) {
return `${e.valueText}%`;
}
function App() {
const [visualRange, setVisualRange] = useState<VisualRange>({ startValue: 'Inner Core', endValue: 'Upper Crust' });
const updateVisualRange = useCallback((e: RangeSelectorTypes.ValueChangedEvent) => {
setVisualRange(e.value);
}, [setVisualRange]);
return (
<>
<Chart
id="zoomedChart"
palette="Soft"
title="The Chemical Composition of the Earth Layers"
dataSource={dataSource}
>
{seriesList}
<ValueAxis>
<Label customizeText={formatValueAxisLabel} />
</ValueAxis>
<ArgumentAxis visualRange={visualRange} />
<CommonSeriesSettings type="bar" ignoreEmptyPoints={true} />
<Legend visible={true}
verticalAlignment="top"
horizontalAlignment="right"
orientation="horizontal"
>
<Border visible={true} />
</Legend>
</Chart>
<RangeSelector
dataSource={dataSource}
onValueChanged={updateVisualRange}
>
<Size height={120} />
<Margin left={10} />
<Scale minorTickCount={1} startValue="Inner Core" endValue="Upper Crust" />
<Behavior valueChangeMode="onHandleMove" />
<ChartOptions palette="Soft">
{rsChartSeriesList}
<Legend visible={false} />
<CommonSeriesSettingsOptions type="bar" ignoreEmptyPoints ={true} />
</ChartOptions>
</RangeSelector>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import Chart, {
ValueAxis,
Label,
Legend,
ArgumentAxis,
CommonSeriesSettings,
Border,
Series,
} from 'devextreme-react/chart';
import RangeSelector, {
Size,
Chart as ChartOptions,
Margin,
Scale,
Behavior,
CommonSeriesSettings as CommonSeriesSettingsOptions,
Series as RsChartSeries,
} from 'devextreme-react/range-selector';
import { series, dataSource } from './data.js';
const seriesList = series.map((item) => (
<Series
valueField={item.valueField}
name={item.name}
key={item.name}
/>
));
const rsChartSeriesList = series.map((item) => (
<RsChartSeries
valueField={item.valueField}
name={item.name}
key={item.name}
/>
));
function formatValueAxisLabel(e) {
return `${e.valueText}%`;
}
function App() {
const [visualRange, setVisualRange] = useState({
startValue: 'Inner Core',
endValue: 'Upper Crust',
});
const updateVisualRange = useCallback(
(e) => {
setVisualRange(e.value);
},
[setVisualRange],
);
return (
<>
<Chart
id="zoomedChart"
palette="Soft"
title="The Chemical Composition of the Earth Layers"
dataSource={dataSource}
>
{seriesList}
<ValueAxis>
<Label customizeText={formatValueAxisLabel} />
</ValueAxis>
<ArgumentAxis visualRange={visualRange} />
<CommonSeriesSettings
type="bar"
ignoreEmptyPoints={true}
/>
<Legend
visible={true}
verticalAlignment="top"
horizontalAlignment="right"
orientation="horizontal"
>
<Border visible={true} />
</Legend>
</Chart>
<RangeSelector
dataSource={dataSource}
onValueChanged={updateVisualRange}
>
<Size height={120} />
<Margin left={10} />
<Scale
minorTickCount={1}
startValue="Inner Core"
endValue="Upper Crust"
/>
<Behavior valueChangeMode="onHandleMove" />
<ChartOptions palette="Soft">
{rsChartSeriesList}
<Legend visible={false} />
<CommonSeriesSettingsOptions
type="bar"
ignoreEmptyPoints={true}
/>
</ChartOptions>
</RangeSelector>
</>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const series = [{
name: 'Si',
valueField: 'Si',
}, {
name: 'Fe',
valueField: 'Fe',
}, {
name: 'Ni',
valueField: 'Ni',
}, {
name: 'S',
valueField: 'S',
}, {
name: 'O',
valueField: 'O',
}, {
name: 'Mg',
valueField: 'Mg',
}, {
name: 'Al',
valueField: 'Al',
}, {
name: 'K',
valueField: 'K',
}, {
name: 'Na',
valueField: 'Na',
}];
const dataSource = [{
arg: 'Inner Core',
Si: 7.35,
Fe: 79.39,
Ni: 5.2,
S: 2.3,
O: 4.1,
}, {
arg: 'Outer Core',
Si: 7.33,
Fe: 78.56,
Ni: 5.2,
S: 2.7,
O: 4.2,
}, {
arg: 'Lower Mantle',
Si: 21.5,
Fe: 5.8,
O: 44.8,
Mg: 22.8,
Al: 2.2,
Ca: 2.3,
Na: 0.3,
K: 0.03,
}, {
arg: 'Upper Mantle',
Si: 28.1,
Mg: 23.2,
Fe: 4.3,
Al: 1.2,
Ca: 2.2,
O: 40.3,
Na: 0.2,
}, {
arg: 'Lower Crust',
O: 46.6,
Si: 27.7,
Al: 8.1,
Fe: 5,
Ca: 3.6,
Na: 2.8,
K: 2.6,
Mg: 1.5,
}, {
arg: 'Upper Crust',
O: 47,
Si: 29.5,
Al: 8.05,
Fe: 4.66,
Ca: 2.96,
Na: 2.5,
K: 2.5,
Mg: 1.87,
}];
export
{
series,
dataSource,
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const series = [
{
name: 'Si',
valueField: 'Si',
},
{
name: 'Fe',
valueField: 'Fe',
},
{
name: 'Ni',
valueField: 'Ni',
},
{
name: 'S',
valueField: 'S',
},
{
name: 'O',
valueField: 'O',
},
{
name: 'Mg',
valueField: 'Mg',
},
{
name: 'Al',
valueField: 'Al',
},
{
name: 'K',
valueField: 'K',
},
{
name: 'Na',
valueField: 'Na',
},
];
const dataSource = [
{
arg: 'Inner Core',
Si: 7.35,
Fe: 79.39,
Ni: 5.2,
S: 2.3,
O: 4.1,
},
{
arg: 'Outer Core',
Si: 7.33,
Fe: 78.56,
Ni: 5.2,
S: 2.7,
O: 4.2,
},
{
arg: 'Lower Mantle',
Si: 21.5,
Fe: 5.8,
O: 44.8,
Mg: 22.8,
Al: 2.2,
Ca: 2.3,
Na: 0.3,
K: 0.03,
},
{
arg: 'Upper Mantle',
Si: 28.1,
Mg: 23.2,
Fe: 4.3,
Al: 1.2,
Ca: 2.2,
O: 40.3,
Na: 0.2,
},
{
arg: 'Lower Crust',
O: 46.6,
Si: 27.7,
Al: 8.1,
Fe: 5,
Ca: 3.6,
Na: 2.8,
K: 2.6,
Mg: 1.5,
},
{
arg: 'Upper Crust',
O: 47,
Si: 29.5,
Al: 8.05,
Fe: 4.66,
Ca: 2.96,
Na: 2.5,
K: 2.5,
Mg: 1.87,
},
];
export { series, dataSource };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#zoomedChart {
margin-bottom: 20px;
}